package com.hai.dao;

import com.hai.entity.HighMerchantStoreAccountRecord;
import com.hai.entity.HighMerchantStoreAccountRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighMerchantStoreAccountRecordMapper extends HighMerchantStoreAccountRecordMapperExt {
    @SelectProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="countByExample")
    long countByExample(HighMerchantStoreAccountRecordExample example);

    @DeleteProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighMerchantStoreAccountRecordExample example);

    @Delete({
        "delete from high_merchant_store_account_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_merchant_store_account_record (store_amount_id, mer_id, ",
        "mer_name, store_id, ",
        "store_name, `type`, ",
        "amount, before_amount, ",
        "after_amount, source_type, ",
        "source_id, source_content, ",
        "`status`, create_time, ",
        "op_user_id, op_user_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{storeAmountId,jdbcType=BIGINT}, #{merId,jdbcType=BIGINT}, ",
        "#{merName,jdbcType=VARCHAR}, #{storeId,jdbcType=BIGINT}, ",
        "#{storeName,jdbcType=VARCHAR}, #{type,jdbcType=INTEGER}, ",
        "#{amount,jdbcType=DECIMAL}, #{beforeAmount,jdbcType=DECIMAL}, ",
        "#{afterAmount,jdbcType=DECIMAL}, #{sourceType,jdbcType=INTEGER}, ",
        "#{sourceId,jdbcType=BIGINT}, #{sourceContent,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{opUserId,jdbcType=BIGINT}, #{opUserName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighMerchantStoreAccountRecord record);

    @InsertProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighMerchantStoreAccountRecord record);

    @SelectProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_amount_id", property="storeAmountId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighMerchantStoreAccountRecord> selectByExample(HighMerchantStoreAccountRecordExample example);

    @Select({
        "select",
        "id, store_amount_id, mer_id, mer_name, store_id, store_name, `type`, amount, ",
        "before_amount, after_amount, source_type, source_id, source_content, `status`, ",
        "create_time, op_user_id, op_user_name, ext_1, ext_2, ext_3",
        "from high_merchant_store_account_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_amount_id", property="storeAmountId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighMerchantStoreAccountRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighMerchantStoreAccountRecord record, @Param("example") HighMerchantStoreAccountRecordExample example);

    @UpdateProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighMerchantStoreAccountRecord record, @Param("example") HighMerchantStoreAccountRecordExample example);

    @UpdateProvider(type=HighMerchantStoreAccountRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighMerchantStoreAccountRecord record);

    @Update({
        "update high_merchant_store_account_record",
        "set store_amount_id = #{storeAmountId,jdbcType=BIGINT},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "store_id = #{storeId,jdbcType=BIGINT},",
          "store_name = #{storeName,jdbcType=VARCHAR},",
          "`type` = #{type,jdbcType=INTEGER},",
          "amount = #{amount,jdbcType=DECIMAL},",
          "before_amount = #{beforeAmount,jdbcType=DECIMAL},",
          "after_amount = #{afterAmount,jdbcType=DECIMAL},",
          "source_type = #{sourceType,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "source_content = #{sourceContent,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighMerchantStoreAccountRecord record);
}